#!/usr/bin/env python

# Copyright (c) 2010-2011 Red Hat, Inc.
#
# This file is part of HekaFS.
#
# HekaFS is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License, version 3, as published by the Free
# Software Foundation.
#
# HekaFS is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License * along
# with HekaFS.  If not, see <http://www.gnu.org/licenses/>.

import sys
import volfilter

if len(sys.argv) != 3:
	print >> sys.stderr, "Usage: %s orig_volfile key" % sys.argv[0]
	sys.exit(1)

graph, last = volfilter.load(sys.argv[1])
# Quick-read bypasses the calls that crypto uses.
to_do = [xl for xl in graph.itervalues() if xl.type == "performance/quick-read"]
for td in to_do:
	volfilter.delete(graph,td)
to_do = [xl for xl in graph.itervalues() if xl.type == "protocol/client"]
for td in to_do:
	volfilter.push_filter(graph,td,"encryption/crypto",{"key":sys.argv[2]})
volfilter.generate(graph,last)
