#!/usr/bin/env python

# Copyright (c) 2010-2011 Red Hat, Inc.
#
# This file is part of HekaFS.
#
# HekaFS is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License, version 3, as published by the Free
# Software Foundation.
#
# HekaFS is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License * along
# with HekaFS.  If not, see <http://www.gnu.org/licenses/>.

import sys
import volfilter

if len(sys.argv) != 3:
	print >> sys.stderr, "Usage: %s orig_volfile quota" % sys.argv[0]
	sys.exit(1)

graph, last = volfilter.load(sys.argv[1])
new_xl = volfilter.Translator(last.name+"-quota")
new_xl.type = "features/quota"
new_xl.opts = {"disk-usage-limit":sys.argv[2]}
new_xl.subvols = last.subvols
last.subvols = [new_xl]
volfilter.generate(graph,last)
